// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_UEdGraph.h"
#include "ISCW_UClass.h"
#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_FBPInterfaceDescription
	{
	public:
		virtual ~ISCW_FBPInterfaceDescription() = default;

		virtual vector<ISCW_UEdGraphPtr> GetGraphs() const = 0;

		virtual ISCW_UClassPtr GetInterface() const = 0;
		virtual void SetInterface(ISCW_UClassConstPtr InInterface) = 0;

		virtual shared_ptr<ISCW_FBPInterfaceDescription> ToFBPInterfaceDescriptionPtr() = 0;
		virtual shared_ptr<const ISCW_FBPInterfaceDescription> ToFBPInterfaceDescriptionPtr() const = 0;
	};

	using ISCW_FBPInterfaceDescriptionConstPtr = shared_ptr<const ISCW_FBPInterfaceDescription>;
	using ISCW_FBPInterfaceDescriptionPtr = shared_ptr<ISCW_FBPInterfaceDescription>;
} // namespace Sourcify